--- openocd/src/target/target.c.orig	2007-03-01 09:20:31.000000000 -0300
+++ openocd/src/target/target.c	2007-03-01 09:33:18.000000000 -0300
@@ -1223,7 +1223,17 @@
 	struct timeval timeout, now;
 	
 	gettimeofday(&timeout, NULL);
-	timeval_add_time(&timeout, 5, 0);
+	if (!argc)
+		timeval_add_time(&timeout, 5, 0);
+	else {
+		char *end;
+
+		timeval_add_time(&timeout, strtoul(args[0], &end, 0), 0);
+		if (*end) {
+			command_print(cmd_ctx, "usage: wait_halt [seconds]");
+			return ERROR_OK;
+		}
+	}
 
 	command_print(cmd_ctx, "waiting for target halted...");
 
